<?php

include "functions/premium.php";

// Chemin du script
$path = pathinfo('http://'.$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']);
$path = $path['dirname'];
// Categorie par dfaut
$default = $CONFIG['cat_defaut'];

// Initialisation des variables du formulaire
$name = isset($_POST['title']) ? ucfirst($_POST['title']) : "";
$url = isset($_POST['url']) ? $_POST['url'] : "http://";
$description = isset($_POST['description']) ? $_POST['description'] : "";
$category = isset($_POST['category']) ? $_POST['category'] : 0;
$email = isset($_POST['email']) ? $_POST['email'] : "";
$url_image = isset($_POST['url_image']) ? $_POST['url_image'] : "";
$action = isset($_POST['action']) ? $_POST['action'] : "";

// Rcupration de la catgorie parcourue par rfrent
if (isset($_SERVER['HTTP_REFERER']))
{
	if (ereg("(.*)index.php\?dir=([0-9]+)", $_SERVER['HTTP_REFERER'], $regs) OR ereg("(.+)-([0-9]+)", $_SERVER['HTTP_REFERER'], $regs))
	{
		$default = $regs[2];
	}
	else if(isset($_REQUEST['category']) && $_REQUEST['category'] != 0 && $_REQUEST['category'] != '')
	{
		$default = $_REQUEST['category'];
	}
	
	$cm =& get_manager("category");
	$mycategory =& $cm->get($default,array('id','usable'));
	
	if($mycategory)
	{
		if ($mycategory->getVar("usable") == 0)
		{
			$default = $CONFIG['cat_defaut'];
		}
		else
		{
			$default = $mycategory->getVar("id");
		}
	}
	else
	{
		$default = $CONFIG['cat_defaut'];
	}
}

// Determination de l'action a suivre
switch($action)
{
	// Cas par defaut
	default:
	case '':
		if($CONFIG['get_meta_tags'])
		{
			$smarty->assign("default_cat",$default);
			$template = 'premium_detect_form.html';
		}
		else
		{
			getAddSiteForm($name, $url, $description, $category, $email, $url_image, $default);
			$template = 'premium_add_form.html';
		}
		break;
	
	// Soumission d'un site
	case 'submit_site':
		addSite($name, $url, $description, $category, $email, $url_image, $default);
		$template = 'form_result.html';
		break;
	
	// Detection des metas et image puis prremplissage du formulaire
	case 'meta_send':
		if($url != '' && $url != 'http://')
		{
			list($url,$url_image,$nom_proprio,$email,$name,$description) = preremplir_formulaire($url,true);
		}
	// Detection contourne
	case 'meta_pass':
		getAddSiteForm($name, $url, $description, $category, $email, $url_image, $default);
		$template = 'premium_add_form.html';
		break;
}

$smarty->clear_cache($template,$cache_id);

?>